-- --------------------------------------------------------------------
-- @author: shiraho@syg.com(必填, 创建模块的人员)
-- @description:
--      32强赛中的第一个标签内容,及时集齐4组32强列表的
-- <br/>Create: new Date().toISOString()
--
-- --------------------------------------------------------------------
ArenaChampionTop321View = class("ArenaChampionTop321View", function()
	return ccui.Layout:create()
end)

local table_sort = table.sort
local table_insert = table.insert
local game_net = GameNet:getInstance()
local string_format = string.format

function ArenaChampionTop321View:ctor(view_type)
    self.root_wnd = createCSBNote(PathTool.getTargetCSB("gw_arena/gw_arena_champion_top_32_1_view"))

	self.tab_list = {}
    self.video_group = 0
    self.video_pos = 0
    self.size = self.root_wnd:getContentSize()
    self:setContentSize(self.size)

    self.root_wnd:setAnchorPoint(0.5, 0.5)
    self.root_wnd:setPosition(self.size.width * 0.5, self.size.height * 0.5)
    self:addChild(self.root_wnd)

    self.view_type = view_type or ArenaConst.champion_type.normal
    if self.view_type == ArenaConst.champion_type.normal then
        self.ctrl = ArenaController:getInstance()
        self.model = self.ctrl:getChampionModel()
    else
        self.ctrl = CrosschampionController:getInstance()
        self.model = self.ctrl:getModel()
    end

    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())
    local bg_res = PathTool.getPlistImgForDownLoad("gw_arena", "gw_arena_09_bg_Cup", true)
    if not self.background_load then
        self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
    end
    self.container = self.root_wnd:getChildByName("container")

    self.left_btn = self.root_wnd:getChildByName("left_btn")
    self.right_btn = self.root_wnd:getChildByName("right_btn")

    self.group_info = self.root_wnd:getChildByName("group_info")
    self.group_info_container = self.group_info:getChildByName("container")
    self.group_info_container:setScrollBarEnabled(false)
    self.group_info_container_size = self.group_info_container:getContentSize()

    --商店
    self.shop_btn = self.root_wnd:getChildByName("shop_btn")
    self.shop_btn_label = self.shop_btn:getChildByName("label")
    StringUtil.gw_setLabelContent(self.shop_btn_label, UI_TI18N(67002), 110)
    self.shop_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            if self.view_type == ArenaConst.champion_type.normal then
                MallController:getInstance():openMallPanel(true, MallConst.MallType.ArenaShop)
            else
                CrosschampionController:getInstance():openCrosschampionShopWindow(true)
            end
        end
    end)
    --名人堂
    self.rank_btn = self.root_wnd:getChildByName("rank_btn")
    self.rank_btn_label = self.rank_btn:getChildByName("label")
    StringUtil.gw_setLabelContent(self.rank_btn_label, UI_TI18N(67003), 110)
    self.rank_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ArenaController:getInstance():gw_openArenaChampionRankHallWindow(true, self.view_type)
        end
    end)
    --竞猜
    self.guess_btn = self.root_wnd:getChildByName("guess_btn")
    self.guess_btn_redpoint = self.guess_btn:getChildByName("redpoint")
    self.guess_btn_label = self.guess_btn:getChildByName("label")
    StringUtil.gw_setLabelContent(self.guess_btn_label, UI_TI18N(67004), 110)
    self.guess_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ArenaController:getInstance():openArenaChampionMatchWindow(true, ArenaConst.champion_index.guess, self.view_type)
            --ArenaController:getInstance():openArenaChampionMyGuessWindow(true, self.view_type)
        end
    end)
    --排行奖励
    self.rank_reward_btn = self.root_wnd:getChildByName("rank_reward_btn")
    self.rank_reward_btn_label = self.rank_reward_btn:getChildByName("label")
    StringUtil.gw_setLabelContent(self.rank_reward_btn_label, UI_TI18N(67005), 110)
    self.rank_reward_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ArenaController:getInstance():openArenaChampionRankAwardsWindow(true, self.view_type, 2)
        end
    end)

    --我的竞赛
    self.my_battle_btn = self.root_wnd:getChildByName("my_battle_btn")
    self.my_battle_btn:setVisible(false)
    self.my_battle_btn_redpoint = self.my_battle_btn:getChildByName("redpoint")
    self.my_battle_btn_label = self.my_battle_btn:getChildByName("label")
    StringUtil.gw_setLabelContent(self.my_battle_btn_label, UI_TI18N(67006), 120)
    self.my_battle_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ArenaController:getInstance():openArenaChampionMatchWindow(true, ArenaConst.champion_index.my_match, self.view_type)
        end
    end)
    --self.notice_label = createLabel(22, cc.c4b(0xff,0x8d,0x55,0xff), 2, 640, 350, "", self.container, nil, cc.p(0.5,0))
end

function ArenaChampionTop321View:addToParent(status)
    self:setVisible(status)
    self:handleEvent(status)
end

function ArenaChampionTop321View:handleEvent(status)
    if status == false then
        if self.update_top32_info_event ~= nil then
            GlobalEvent:getInstance():UnBind(self.update_top32_info_event)
            self.update_top32_info_event = nil
        end
        if self.update_324_guess_event ~= nil then
            GlobalEvent:getInstance():UnBind(self.update_324_guess_event)
            self.update_324_guess_event = nil
        end
        if self.update_my_match_info_event ~= nil then
            GlobalEvent:getInstance():UnBind(self.update_my_match_info_event)
            self.update_my_match_info_event = nil
        end
    else
        if self.update_top32_info_event == nil then
            self.update_top32_info_event = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateTop32InfoEvent, function(list) 
                self:updateTop32InfoList(list)
            end)
        end

        if self.update_324_guess_event == nil then
            self.update_324_guess_event = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateTop324GuessGroupEvent, function(group,pos)
                self.video_group = group
                self.video_pos = pos
                --if group == 0 or pos == 0 then return end
                --
                --local panel = self.tab_list[group]
                --if panel and panel.updateGuessStatus then
                --    panel:updateGuessStatus(true, pos)
                --end
            end)
        end

        if self.update_my_match_info_event == nil then
            self.update_my_match_info_event = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateMyMatchInfoEvent, function(data)
                local my_battle_redpoint = false
                local base_info = self.model:getBaseInfo()
                local role_info = self.model:getRoleInfo()
                if base_info ~= nil and role_info ~= nil then
                    if self.model:getMyMatchStatus() == ArenaConst.champion_my_status.in_match and
                            base_info.round_status == ArenaConst.champion_round_status.prepare then
                        if getNorKey(base_info.step, base_info.round) == getNorKey(data.step, data.round) then
                            my_battle_redpoint = true
                        end
                    end
                end

                if my_battle_redpoint == true and self.my_battle_btn_redpoint_spine == nil then
                    self.my_battle_btn_redpoint_spine = PathTool.gw_createRedpointSpine()
                    self.my_battle_btn_redpoint:addChild(self.my_battle_btn_redpoint_spine)
                end
                self.my_battle_btn_redpoint:setVisible(my_battle_redpoint)
            end)
        end
    end
end

function ArenaChampionTop321View:updateCheckStatus(cur_page)
    if self.gw_group_item_list then
        for i,v in pairs(self.gw_group_item_list) do
            v:setSelect(i == cur_page)
        end

        if cur_page == 1 then
            self.group_info_container:jumpToLeft()
        elseif cur_page == #self.gw_group_item_list then
            self.group_info_container:jumpToRight()
        end

    end
    ----self.notice_label:setString(ArenaConst.getGroup(cur_page))
    --if self.video_group == 0 or self.video_pos == 0 then return end
    --if self.video_group and self.video_group == cur_page and self.video_pos then
    --    local panel = self.tab_list[cur_page]
    --    if panel then
    --        panel:updateGuessStatus(true, self.video_pos)
    --    end
    --end
end

function ArenaChampionTop321View:updateInfo(status)
    local base_info = self.model:getBaseInfo()
    local role_info = self.model:getRoleInfo()
    if base_info == nil or role_info == nil then return end

    if self.model:getMyMatchStatus() == ArenaConst.champion_my_status.in_match then
        if base_info.round_status == ArenaConst.champion_round_status.prepare then
            if self.view_type == ArenaConst.champion_type.normal then
                self.ctrl:requestMyChampionMatch()
            else
                self.ctrl:sender26202()
            end
        else
            self.my_battle_btn_redpoint:setVisible(false)
        end
        self.my_battle_btn:setVisible(true)
    else
        self.my_battle_btn:setVisible(false)
    end

    if base_info.round_status == ArenaConst.champion_round_status.guess then
        self.guess_btn_redpoint_spine = PathTool.gw_createRedpointSpine()
        self.guess_btn_redpoint:addChild(self.guess_btn_redpoint_spine)
        self.guess_btn_redpoint:setVisible(true)
    else
        self.guess_btn_redpoint:setVisible(false)
    end

    if base_info.step == ArenaConst.champion_step.match_64 and role_info.rank > 64 then
        --self.notice_label:setString(TI18N("您未进入64强"))
    elseif base_info.step == ArenaConst.champion_step.match_32 and role_info.rank > 32 then
        --self.notice_label:setString(TI18N("您未进入32强"))
    else
        if base_info.step == ArenaConst.champion_step.match_64 then
            if base_info.round == 2 and role_info.rank > 32 then
                --self.notice_label:setString(TI18N("您未进入32强"))
            elseif base_info.round == 3 and role_info.rank > 16 then
                --self.notice_label:setString(TI18N("您未进入16强"))
            else
                --self.my_battle_btn:setVisible(true)
                --self.notice_label:setVisible(false)
            end
        elseif base_info.step == ArenaConst.champion_step.match_32 then
            if base_info.round == 2 and role_info.rank > 16 then
                --self.notice_label:setString(TI18N("您未进入16强"))
            elseif base_info.round == 3 and role_info.rank > 8 then
                --self.notice_label:setString(TI18N("您未进入8强"))
            else
                --self.my_battle_btn:setVisible(true)
                --self.notice_label:setVisible(false)
            end
        elseif base_info.step == ArenaConst.champion_step.match_8 then
            if base_info.round == 1 and role_info.rank > 8 then
                --self.notice_label:setString(TI18N("您未进8强赛"))
            elseif base_info.round == 2 and role_info.rank > 4 then
                --self.notice_label:setString(TI18N("您未进入半决赛"))
            elseif base_info.round == 3 and role_info.rank > 2 then
                --self.notice_label:setString(TI18N("您未进入决赛"))
            else
                --self.my_battle_btn:setVisible(true)
                --self.notice_label:setVisible(false)
            end
        elseif base_info.step == ArenaConst.champion_step.match_4 then
            if base_info.round == 1 and role_info.rank > 4 then     -- 未进入4强强
                --self.notice_label:setString(TI18N("您未进4强赛"))
            elseif base_info.round == 2 and role_info.rank > 2 then -- 未进入决赛
                --self.notice_label:setString(TI18N("您未进入决赛"))
            else
                --self.my_battle_btn:setVisible(true)
                --self.notice_label:setVisible(false)
            end
        else
            --self.my_battle_btn:setVisible(true)
            --self.notice_label:setVisible(false)
        end
    end

    self.is_change_tab = status
    if status == true or base_info.flag ~= 0 then
        if self.view_type == ArenaConst.champion_type.normal then
            self.ctrl:requestTop32Info()
        else
            self.ctrl:sender26209()
        end
    end
end

--==============================--
--desc:更新32强数据,可能是已经创建了,也可能还未创建
--time:2018-08-06 10:07:49
--@data:
--@return 
--==============================--
function ArenaChampionTop321View:updateTop32InfoList(list)
    if list == nil then return end
    -- 这里做一个排序
    table_sort( list, function(a, b) 
        return a.group < b.group
    end)
    -- 保存pageview的当前数据
    self.page_view_list = list 
    if self.page_view == nil then
        if self.page_view == nil then
            local tot_page = 4
            if self.view_type == ArenaConst.champion_type.cross then
                tot_page = 8
            end

            self.gw_group_item_list = {}
            local start_x = 84
            for i=1,tot_page do
                local item = GW_ArenaChampionTop321ViewGroupItem.new(i)
                item:setPosition(cc.p(start_x + 161*(i-1), 31))
                self.group_info_container:addChild(item)
                self.gw_group_item_list[i] = item
                self.gw_group_item_list[i]:addTouchEventListener(function(sender, event_type)
                    customClickAction_4(sender, event_type)
                    if event_type == ccui.TouchEventType.ended then
                        playButtonSound2()
                        if self.page_view and self.page_view.page_view then
                            local cur_index = self.page_view.page_view:getCurrentPageIndex()
                            local target_index = i-1
                            if target_index == cur_index then return end

                            if target_index > cur_index then
                                if target_index > (cur_index + 1) then
                                    for kk=cur_index,target_index do
                                        self.page_view:createPageItem(kk)
                                    end
                                end
                            else
                                if target_index < (cur_index - 1) then
                                    for kk=target_index,cur_index do
                                        self.page_view:createPageItem(kk)
                                    end
                                end
                            end
                            doScrollToPage(self.page_view.page_view, target_index)
                        end
                    end
                end)
            end
            local max_width = 161*tot_page + 7
            if max_width < self.group_info_container_size.width then
                max_width = self.group_info_container_size.width
            end
            self.group_info_container:setInnerContainerSize(cc.size(max_width, self.group_info_container_size.height))

            self.page_view = CustomPageView.new(self.size, true, false, 0, 0, tot_page, self.left_btn, self.right_btn)
            self.page_view.page_view:setTouchEnabled(false)
            self.container:addChild(self.page_view)
            self.page_view.per_page = 1

            -- 不能用参数的数据做处理,因为后面2页可能没切换的时候还是旧数据,当切换的时候不能用旧数据做处理
            local function createPage(data_list, page, layout)
                page = page or 1
                local item = ArenaChampionTop32Item.new(self.view_type)
                local temp_data = self.page_view_list[page]
                item:setData(temp_data)
                layout:addChild(item)
                table_insert(self.tab_list, item)
            end
            local function turnPage(cur_page, page_sum)
                self:updateCheckStatus(cur_page)
            end
            self.page_view:addCreatePageCallBack(createPage)
            self.page_view:addTurnCallBack(turnPage)
            self.page_view:setViewData(list)
        end
    else
        for i, panel in ipairs(self.tab_list) do
            panel:setData(list[i])
        end
    end
    --同步请求一下竞猜位置信息
    if self.view_type == ArenaConst.champion_type.normal then
        self.ctrl:requestGuessGroupInfo()
    else
        self.ctrl:sender26211()
    end
end

function ArenaChampionTop321View:DeleteMe()
    --if self.my_battle_btn_redpoint ~= nil then
    --    self.my_battle_btn_redpoint:clearTracks()
    --    self.my_battle_btn_redpoint:removeFromParent()
    --    self.my_battle_btn_redpoint = nil
    --end
    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end
    self:handleEvent(false)
    for k, panel in pairs(self.tab_list) do
        panel:DeleteMe()
    end
    self.tab_list = nil

    if self.gw_group_item_list then
        for i,v in pairs(self.gw_group_item_list) do
            v:DeleteMe()
        end
        self.gw_group_item_list = nil
    end
    if self.page_view then
        self.page_view:dispose()
    end
    self.page_view = nil

    if self.my_battle_btn_redpoint_spine then
        self.my_battle_btn_redpoint_spine:clearTracks()
        self.my_battle_btn_redpoint_spine:removeFromParent()
        self.my_battle_btn_redpoint_spine = nil
    end
    if self.guess_btn_redpoint_spine then
        self.guess_btn_redpoint_spine:clearTracks()
        self.guess_btn_redpoint_spine:removeFromParent()
        self.guess_btn_redpoint_spine = nil
    end
end 



-- --------------------------------------------------------------------
-- @author: shiraho@syg.com(必填, 创建模块的人员)
-- @description:
--      32强赛分页内容
-- <br/>Create: new Date().toISOString()
--
-- --------------------------------------------------------------------
ArenaChampionTop32Item = class("ArenaChampionTop32Item", function()
	return ccui.Layout:create()
end)

function ArenaChampionTop32Item:ctor(view_type)
    self.view_type = view_type
    if self.view_type == ArenaConst.champion_type.normal then
        self.ctrl = ArenaController:getInstance()
        self.model = self.ctrl:getChampionModel()
    else
        self.ctrl = CrosschampionController:getInstance()
        self.model = self.ctrl:getModel()
    end
	self.root_wnd = createCSBNote(PathTool.getTargetCSB("gw_arena/gw_arena_champion_top_32_item"))
	
	self.size = self.root_wnd:getContentSize()
	self:setContentSize(self.size)
	
	self.root_wnd:setAnchorPoint(0.5, 0.5)
	self.root_wnd:setPosition(self.size.width * 0.5, self.size.height * 0.5)
	self:addChild(self.root_wnd)
	
	local container = self.root_wnd:getChildByName("container")
    self.champion_bg = container:getChildByName("champion_bg")
    local bg_res = PathTool.getPlistImgForDownLoad("gw_arena", "gw_arena_13_img_champion", false)
    if not self.champion_bg_load then
        self.champion_bg_load = loadSpriteTextureFromCDN(self.champion_bg, bg_res, ResourcesType.single, self.champion_bg_load)
    end

    self.line_spine_node = container:getChildByName("line_spine_node")
    self.line_spine_action = "0-jingtai"
    self.line_spine = gw_createEffectSpine("E90402", cc.p(0, 0), cc.p(0.5, 0.5), true, self.line_spine_action)
    --self.line_spine = gw_createEffectSpine("E90402", cc.p(0, 0), cc.p(0.5, 0.5), true, "1-chujie")
    --self.line_spine = gw_createEffectSpine("E90402", cc.p(0, 0), cc.p(0.5, 0.5), true, "2-zhongjie")
    --self.line_spine = gw_createEffectSpine("E90402", cc.p(0, 0), cc.p(0.5, 0.5), true, "3-juesai")
    self.line_spine_node:addChild(self.line_spine)

    -- 找出属于每一个位置的线
    local lines = container:getChildByName("lines")
    self.pos_line_list = {}
    for i=1,14 do
        local pos_line = lines:getChildByName("gw_pos_line_"..i)
        local select = pos_line:getChildByName("select")
        select:setVisible(false)
        local object = {}
        object.select = select
        select:setVisible(false)
        self.pos_line_list[i] = object
    end

    -- 找出当前位角色底图和名字
    local roles = container:getChildByName("roles")
    self.role_pos_list = {}
    for i=1,15 do
        local role_pos = roles:getChildByName("gw_role_pos_"..i)
        local empty = role_pos:getChildByName("empty")
        local role_info = role_pos:getChildByName("role_info")
        local object = {}
        object.empty = empty
        object.empty_label = empty:getChildByName("label")
        object.role_info = role_info
        object.role_info_head_node = role_info:getChildByName("head_node")
        object.role_info_name = role_info:getChildByName("name")
        object.role_info_head_info = role_info:getChildByName("head_info")
        object.role_info_head_info_head_node = object.role_info_head_info:getChildByName("head_node")
        object.role_info_head_info_head = PlayerHead.new(PlayerHead.type.square, 0)
        object.role_info_head_info_head:setPosition(0, 0)
        object.role_info_head_info_head:setScale(1)
        object.role_info_head_info_head_node:addChild(object.role_info_head_info_head)
        object.role_info_head_info_lev = object.role_info_head_info:getChildByName("lev_bg"):getChildByName("lev_label")
        object.check_info = role_pos:getChildByName("check_info")
        if object.check_info then
            object.check_info_check_btn = object.check_info:getChildByName("check_btn")
            object.check_info:setVisible(false)
        end

        object.empty:setVisible(true)
        object.role_info:setVisible(false)
        self.role_pos_list[i] = object

        if object.role_info_head_info ~= nil then
            object.role_info_head_info:addTouchEventListener(function(sender, event_type)
                if event_type == ccui.TouchEventType.ended then
                    playButtonSound2()
                    if self.data then
                        --Debug.info(self.data)
                        if self.data.pos_list and self.data.pos_list[i] and self.data.pos_list[i].rid and self.data.pos_list[i].srv_id then
                            FriendController:getInstance():openFriendCheckPanel(true, {srv_id = self.data.pos_list[i].srv_id, rid = self.data.pos_list[i].rid, gw_is_hide_pk = true})
                        end
                    end
                end
            end)
        end
        if object.check_info_check_btn ~= nil then
            object.check_info_check_btn:addTouchEventListener(function(sender, event_type)
                customClickAction_4(sender, event_type)
                if event_type == ccui.TouchEventType.ended then
                    playButtonSound2()
                    if self.data then
                        GlobalEvent:getInstance():Fire(ArenaEvent.CheckFightInfoEvent, true, self.data.group, 2*(i-8)-1)
                    end
                end
            end)
        end
    end

    --self.guess_btn = container:getChildByName("guess_btn")
    --self.guess_btn:getChildByName("label"):setString(TI18N("竞猜"))
    --self.guess_btn:setVisible(false)
    self:registerEvent()

    if self.view_type == ArenaConst.champion_type.normal then-- 本服冠军赛
        for i=1,8 do
            local object = self.role_pos_list[i]
            object.empty_label:setString(UI_TI18N(67008))
        end
        for i=9,12 do
            local object = self.role_pos_list[i]
            object.empty_label:setString(UI_TI18N(67009))
        end
        for i=13,14 do
            local object = self.role_pos_list[i]
            object.empty_label:setString(UI_TI18N(67010))
        end
        for i=15,15 do
            local object = self.role_pos_list[i]
            object.empty_label:setString(UI_TI18N(67011))
        end
    elseif self.view_type == ArenaConst.champion_type.cross then-- 跨服冠军赛
        for i=1,8 do
            local object = self.role_pos_list[i]
            object.empty_label:setString(UI_TI18N(67007))
        end
        for i=9,12 do
            local object = self.role_pos_list[i]
            object.empty_label:setString(UI_TI18N(67008))
        end
        for i=13,14 do
            local object = self.role_pos_list[i]
            object.empty_label:setString(UI_TI18N(67009))
        end
        for i=15,15 do
            local object = self.role_pos_list[i]
            object.empty_label:setString(UI_TI18N(67010))
        end
    end

    self.panel_title = container:getChildByName("panel_title")
    self.panel_title:setVisible(false)
    self.time_info = container:getChildByName("time_info")
    self.time_info:setVisible(false)
    self.time_info_bg = self.time_info:getChildByName("bg")
    self.time_info_label = self.time_info:getChildByName("label")
end

function ArenaChampionTop32Item:registerEvent()
    --for k,check_btn in pairs(self.check_btn_list) do
    --    check_btn:addTouchEventListener(function(sender, event_type)
    --        if event_type == ccui.TouchEventType.ended then
    --            playButtonSound2()
    --            if self.data then
    --                GlobalEvent:getInstance():Fire(ArenaEvent.CheckFightInfoEvent, true, self.data.group, k)
    --            end
    --        end
    --    end)
    --end
    --self.guess_btn:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        GlobalEvent:getInstance():Fire(ArenaEvent.ChangeTanFromTop324)
    --    end
    --end)
end

----==============================--
----desc:设置竞猜显示
----time:2018-08-06 11:39:25
----@status:
----@return
----==============================--
--function ArenaChampionTop32Item:updateGuessStatus(status, pos)
--    self.guess_btn:setVisible(status)
--    if status == true and pos ~= nil then
--        local target_check = self.check_btn_list[pos]
--        if target_check then
--            self.guess_btn:setPosition(target_check:getPositionX(), target_check:getPositionY())
--        end
--    end
--end

function ArenaChampionTop32Item:setData(data)
    self:updateBaseInfo()

    for i, line_pos in pairs(self.pos_line_list) do
        line_pos.select:setVisible(false)
    end
    for i,role_pos in pairs(self.role_pos_list) do
        role_pos.empty:setVisible(true)
        role_pos.role_info:setVisible(false)
        if role_pos.check_info then
            role_pos.check_info:setVisible(false)
        end
    end

    local base_info = self.model:getBaseInfo()
    --Debug.info(base_info)
    if base_info == nil then
        if self.line_spine_action ~= "0-jingtai" then
            self.line_spine_action = "0-jingtai"
            self.line_spine:setAnimation(0, self.line_spine_action, true)
        end
        return
    end
    if data == nil or data.pos_list == nil or next(data.pos_list) == nil then
        if self.line_spine_action ~= "0-jingtai" then
            self.line_spine_action = "0-jingtai"
            self.line_spine:setAnimation(0, self.line_spine_action, true)
        end
        return
    end
    --self:updateGuessStatus(false)
    self.data = data
    -- 按照位置排序一下
    local pos_list = data.pos_list
    table_sort(pos_list, function(a, b) 
        return a.pos < b.pos
    end)
    --Debug.info(pos_list)
    for k,role_pos in pairs(self.role_pos_list) do
        local pos_info = pos_list[k]
        if pos_info then
            role_pos.role_info_head_info_head:setHeadRes(pos_info.face or 30303, false, LOADTEXT_TYPE, pos_info.face_file, pos_info.face_update_time)
            role_pos.role_info_head_info_lev:setString(pos_info.lev)
            role_pos.role_info_head_info_head:gw_showHeadFrame(pos_info.avatar_bid or pos_info.avatar_id)
            StringUtil.gw_setRoleNickName(role_pos.role_info_name, pos_info.name, 130)
            if role_pos.check_info_check_btn then
                local check_btn_x = 22 - (50 + role_pos.role_info_name:getContentSize().width)/2
                role_pos.check_info_check_btn:setPositionX(check_btn_x)
                local role_info_name_x = 45 - (50 + role_pos.role_info_name:getContentSize().width)/2
                role_pos.role_info_name:setPositionX(role_info_name_x)
            end

            if pos_info.ret == 0 then -- 未打
                setChildUnEnabled(false, role_pos.role_info_head_info_head)
            elseif pos_info.ret == 1 then -- 胜利
                if self.pos_line_list[k] then
                    self.pos_line_list[k].select:setVisible(true)
                end
                setChildUnEnabled(false, role_pos.role_info_head_info_head)
            elseif pos_info.ret == 2 then --失败
                setChildUnEnabled(true, role_pos.role_info_head_info_head)
            end

            role_pos.empty:setVisible(false)
            role_pos.role_info:setVisible(true)
        end
    end

    if base_info.step == ArenaConst.champion_step.unopened then--未开始
        if self.line_spine_action ~= "0-jingtai" then
            self.line_spine_action = "0-jingtai"
            self.line_spine:setAnimation(0, self.line_spine_action, true)
        end
    elseif base_info.step == ArenaConst.champion_step.score then--选拔赛
        if self.line_spine_action ~= "0-jingtai" then
            self.line_spine_action = "0-jingtai"
            self.line_spine:setAnimation(0, self.line_spine_action, true)
        end
        for i,role_pos in pairs(self.role_pos_list) do
            role_pos.empty:setVisible(true)
            role_pos.role_info:setVisible(false)
        end
        for i, line_pos in pairs(self.pos_line_list) do
            line_pos.select:setVisible(false)
        end
    elseif base_info.step == ArenaConst.champion_step.match_32 then--32强赛
        if base_info.round <= 1 then
            if self.line_spine_action ~= "1-chujie" then
                self.line_spine_action = "1-chujie"
                self.line_spine:setAnimation(0, self.line_spine_action, true)
            end
        elseif base_info.round <= 2 then
            if self.line_spine_action ~= "2-zhongjie" then
                self.line_spine_action = "2-zhongjie"
                self.line_spine:setAnimation(0, self.line_spine_action, true)
            end
        elseif base_info.round <= 3 then
            if self.line_spine_action ~= "3-juesai" then
                self.line_spine_action = "3-juesai"
                self.line_spine:setAnimation(0, self.line_spine_action, true)
            end
        else
            if self.line_spine_action ~= "0-jingtai" then
                self.line_spine_action = "0-jingtai"
                self.line_spine:setAnimation(0, self.line_spine_action, true)
            end
        end

        if base_info.round <= 1 then
            for k=9,12 do
                local pos_info = pos_list[k]
                local object = self.role_pos_list[k]
                if pos_info == nil or pos_info.ret == 0 then -- 未打
                    object.check_info:setVisible(false)
                elseif pos_info.ret == 1 then -- 胜利
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                elseif pos_info.ret == 2 then --失败
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                end
            end
        else
            for k=9,12 do
                local object = self.role_pos_list[k]
                object.check_info:setVisible(true)
            end
        end
        if base_info.round <= 1 then

        elseif base_info.round <= 2 then
            for k=13,14 do
                local pos_info = pos_list[k]
                local object = self.role_pos_list[k]
                if pos_info == nil or pos_info.ret == 0 then -- 未打
                    object.check_info:setVisible(false)
                elseif pos_info.ret == 1 then -- 胜利
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                elseif pos_info.ret == 2 then --失败
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                end
            end
        else
            for k=13,14 do
                local object = self.role_pos_list[k]
                object.check_info:setVisible(true)
            end
        end
        if base_info.round <= 2 then

        elseif base_info.round <= 3 then
            for k=15,15 do
                local pos_info = pos_list[k]
                local object = self.role_pos_list[k]
                if pos_info == nil or pos_info.ret == 0 then -- 未打
                    object.check_info:setVisible(false)
                elseif pos_info.ret == 1 then -- 胜利
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                elseif pos_info.ret == 2 then --失败
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                end
            end
        else
            for k=15,15 do
                local object = self.role_pos_list[k]
                object.check_info:setVisible(true)
            end
        end
    elseif base_info.step == ArenaConst.champion_step.match_4 then--4强赛
        if self.line_spine_action ~= "0-jingtai" then
            self.line_spine_action = "0-jingtai"
            self.line_spine:setAnimation(0, self.line_spine_action, true)
        end
        for k=9,15 do
            local object = self.role_pos_list[k]
            object.check_info:setVisible(true)
        end
    elseif base_info.step == ArenaConst.champion_step.match_64 then--64强赛
        if base_info.round <= 1 then
            if self.line_spine_action ~= "1-chujie" then
                self.line_spine_action = "1-chujie"
                self.line_spine:setAnimation(0, self.line_spine_action, true)
            end
        elseif base_info.round <= 2 then
            if self.line_spine_action ~= "2-zhongjie" then
                self.line_spine_action = "2-zhongjie"
                self.line_spine:setAnimation(0, self.line_spine_action, true)
            end
        elseif base_info.round <= 3 then
            if self.line_spine_action ~= "3-juesai" then
                self.line_spine_action = "3-juesai"
                self.line_spine:setAnimation(0, self.line_spine_action, true)
            end
        else
            if self.line_spine_action ~= "0-jingtai" then
                self.line_spine_action = "0-jingtai"
                self.line_spine:setAnimation(0, self.line_spine_action, true)
            end
        end

        if base_info.round <= 1 then
            for k=9,12 do
                local pos_info = pos_list[k]
                local object = self.role_pos_list[k]
                if pos_info == nil or pos_info.ret == 0 then -- 未打
                    object.check_info:setVisible(false)
                elseif pos_info.ret == 1 then -- 胜利
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                elseif pos_info.ret == 2 then --失败
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                end
            end
        else
            for k=9,12 do
                local object = self.role_pos_list[k]
                object.check_info:setVisible(true)
            end
        end
        if base_info.round <= 2 then
            for k=13,14 do
                local pos_info = pos_list[k]
                local object = self.role_pos_list[k]
                if pos_info == nil or pos_info.ret == 0 then -- 未打
                    object.check_info:setVisible(false)
                elseif pos_info.ret == 1 then -- 胜利
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                elseif pos_info.ret == 2 then --失败
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                end
            end
        else
            for k=13,14 do
                local object = self.role_pos_list[k]
                object.check_info:setVisible(true)
            end
        end
        if base_info.round <= 3 then
            for k=15,15 do
                local pos_info = pos_list[k]
                local object = self.role_pos_list[k]
                if pos_info == nil or pos_info.ret == 0 then -- 未打
                    object.check_info:setVisible(false)
                elseif pos_info.ret == 1 then -- 胜利
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                elseif pos_info.ret == 2 then --失败
                    object.check_info_check_btn:setPositionX(0)
                    object.check_info:setVisible(true)
                end
            end
        else
            for k=15,15 do
                local object = self.role_pos_list[k]
                object.check_info:setVisible(true)
            end
        end
    elseif base_info.step == ArenaConst.champion_step.match_8 then--8强赛
        if self.line_spine_action ~= "0-jingtai" then
            self.line_spine_action = "0-jingtai"
            self.line_spine:setAnimation(0, self.line_spine_action, true)
        end
        for k=9,15 do
            local object = self.role_pos_list[k]
            object.check_info:setVisible(true)
        end
    else--未知状态
        if self.line_spine_action ~= "0-jingtai" then
            self.line_spine_action = "0-jingtai"
            self.line_spine:setAnimation(0, self.line_spine_action, true)
        end
        for i,role_pos in pairs(self.role_pos_list) do
            role_pos.empty:setVisible(true)
            role_pos.role_info:setVisible(false)
            if role_pos.check_info then
                role_pos.check_info:setVisible(false)
            end
        end
        for i, line_pos in pairs(self.pos_line_list) do
            line_pos.select:setVisible(false)
        end
    end
end

function ArenaChampionTop32Item:DeleteMe()
    if self.line_spine then
        self.line_spine:clearTracks()
        self.line_spine:removeFromParent()
        self.line_spine = nil
    end
    if self.champion_bg_load then
        self.champion_bg_load:DeleteMe()
        self.champion_bg_load = nil
    end

    if self.role_pos_list then
        for i,v in pairs(self.role_pos_list) do
            if v.role_info_head_info_head then
                v.role_info_head_info_head:DeleteMe()
                v.role_info_head_info_head = nil
            end
        end

        self.role_pos_list = nil
    end

    self:clearTimeTicket()
end

function ArenaChampionTop32Item:updateBaseInfo()
    self.panel_title:setVisible(false)
    self.time_info:setVisible(false)
    local base_info = self.model:getBaseInfo()
    if base_info == nil then return end

    self.panel_title:setVisible(true)
    self:setChampionStepInfo()
    if (base_info.step == ArenaConst.champion_step.match_4 or base_info.step == ArenaConst.champion_step.match_8) and base_info.step_status == ArenaConst.champion_step_status.over then
        self:clearTimeTicket()
        self.time_info:setVisible(false)
    else
        self.time_info:setVisible(true)
        if self.time_ticket == nil then
            self.time_ticket = GlobalTimeTicket:getInstance():add(function()
                self:countDownTimeTicket()
            end, 1)
        end
        self:countDownTimeTicket()
    end
end
--==============================--
--desc:移除时间计时器
--time:2018-08-04 04:40:58
--@return
--==============================--
function ArenaChampionTop32Item:clearTimeTicket()
    if self.time_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.time_ticket)
        self.time_ticket = nil
    end
end

function ArenaChampionTop32Item:countDownTimeTicket()
    local base_info = self.model:getBaseInfo()
    if base_info == nil then
        self:clearTimeTicket()
        return
    end
    local end_time = game_net:getTime()

    if base_info.step == ArenaConst.champion_step.unopened then
        end_time = base_info.step_status_time
    elseif base_info.step == ArenaConst.champion_step.score and base_info.step_status == ArenaConst.champion_step_status.unopened then
        end_time = base_info.step_status_time
    else
        end_time = base_info.round_status_time
    end
    local less_time = end_time - game_net:getTime()
    if less_time < 0 then
        less_time = 0
        self:clearTimeTicket()
    end

    local str_format = ArenaConst.gw_getMatchStepStatusDesc(base_info.step, base_info.round_status)
    local str = StringFormat(str_format, TimeTool.GetTimeFormat(less_time))
    --if base_info.step == ArenaConst.champion_step.unopened or base_info.step_status == ArenaConst.champion_step_status.unopened then
    --    str = string_format(TI18N("距离开始:%s"), TimeTool.GetTimeFormat(less_time))
    --else
    --    if base_info.round_status == ArenaConst.champion_round_status.prepare then
    --        str = string_format(TI18N("准备阶段:%s"), TimeTool.GetTimeFormat(less_time))
    --    elseif base_info.round_status == ArenaConst.champion_round_status.guess then
    --        str = string_format(TI18N("竞猜阶段:%s"), TimeTool.GetTimeFormat(less_time))
    --    else
    --        str = string_format(TI18N("比赛阶段:%s"), TimeTool.GetTimeFormat(less_time))
    --    end
    --end
    --self.time_info_label:setString(str)
    StringUtil.gw_setLabelContent(self.time_info_label, str, 220)
    local max_width = self.time_info_label:getContentSize().width + 10
    if max_width < 164 then max_width = 164 end
    if max_width > 230 then max_width = 230 end
    self.time_info_bg:setContentSize(cc.size(max_width, 34))
end

--==============================--
--desc:设置冠军赛阶段显示,这里需要判断自己是否进入了对应的阶段
--time:2018-08-04 05:44:04
--@return
--==============================--
function ArenaChampionTop32Item:setChampionStepInfo()
    local base_info = self.model:getBaseInfo()
    local role_info = self.model:getRoleInfo()
    if base_info == nil or role_info == nil then return end


    local panel_title_str = ArenaConst.gw_getArenaChampionStepDesc(base_info.step, self.view_type, base_info.step_status, base_info.round, role_info.rank, role_info.group, base_info.step_status_time)
    StringUtil.gw_setLabelContent(self.panel_title, panel_title_str, 280)
end

--------------------------------------------
---- 组子项
GW_ArenaChampionTop321ViewGroupItem = class("GW_ArenaChampionTop321ViewGroupItem", function()
    return ccui.Widget:create()
end)

function GW_ArenaChampionTop321ViewGroupItem:ctor(group)
    self.group = group
    self:configUI()
    self:register_event()
end

function GW_ArenaChampionTop321ViewGroupItem:configUI()
    self.root_wnd = cc.CSLoader:createNode(PathTool.getTargetCSB("gw_arena/gw_arena_champion_top_32_1_view_group_item"))
    self:setContentSize(cc.size(154,46))
    self:addChild(self.root_wnd)

    self.main_panel = self.root_wnd:getChildByName("main_panel")
    self.normal = self.main_panel:getChildByName("normal")
    self.select = self.main_panel:getChildByName("select")
    self.select:setVisible(false)
    self.label = self.main_panel:getChildByName("label")
    self.label:setString(ArenaConst.getGroup(self.group))
    self:setTouchEnabled(false)
end

function GW_ArenaChampionTop321ViewGroupItem:register_event()

end
function GW_ArenaChampionTop321ViewGroupItem:setSelect(_bool)
    self.normal:setVisible(not _bool)
    self.select:setVisible(_bool)
    self:setTouchEnabled(not _bool)
end

function GW_ArenaChampionTop321ViewGroupItem:DeleteMe()
    self:removeAllChildren()
    self:removeFromParent()
end