---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2022/7/10 11:31
--- 冠军赛名人堂
GW_ArenaChampionRankHallWindow = GW_ArenaChampionRankHallWindow or BaseClass(BaseView)

local role_vo = RoleController:getInstance():getRoleVo()

local string_format = string.format
local table_sort = table.sort
local table_insert = table.insert
local table_remove = table.remove

function GW_ArenaChampionRankHallWindow:__init()
    self.ctrl = GW_ArenaHallController:getInstance()
    self.is_full_screen = true
    self.layout_name = "gw_arena/gw_arena_champion_rank_hall_window"

    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_arena", "gw_arena"), type = ResourcesType.plist},
        { path = PathTool.getPlistImgForDownLoad("gw_battle", "gw_battle"), type = ResourcesType.plist},
        { path = PathTool.getPlistImgForDownLoad("gw_guild", "gw_guild"), type = ResourcesType.plist},
        { path = PathTool.getPlistImgForDownLoad("gw_rank", "gw_rank"), type = ResourcesType.plist},
        { path = PathTool.getPlistImgForDownLoad("gw_arena","gw_arena_46_bg_ranking", true), type = ResourcesType.single },
        { path = PathTool.getPlistImgForDownLoad("honor","txt_cn_honor_13", false), type = ResourcesType.single },
        { path = PathTool.getPlistImgForDownLoad("honor","txt_cn_honor_14", false), type = ResourcesType.single },
        { path = PathTool.getPlistImgForDownLoad("honor","txt_cn_honor_15", false), type = ResourcesType.single },
    }

end

--@view_type ArenaConst.champion_type
function GW_ArenaChampionRankHallWindow:openRootWnd(view_type)
    self.view_type = view_type or ArenaConst.champion_type.normal
    if self.view_type == ArenaConst.champion_type.normal then
        self.ctrl = ArenaController:getInstance()
        self.model = self.ctrl:getChampionModel()
    else
        self.ctrl = CrosschampionController:getInstance()
        self.model = self.ctrl:getModel()
    end
    --
    --if self.view_type == ArenaConst.champion_type.normal then
    --    self.ctrl:requestChompionRank()
    --else
    --    self.ctrl:sender26214()
    --end

    if self.view_type == ArenaConst.champion_type.normal then
        self.ctrl:requestChampionTop3()
    else
        self.ctrl:sender26213()
    end

    self:updateTopNumWealth()
end

function GW_ArenaChampionRankHallWindow:open_callback()
    self.left_top_container = self.root_wnd:getChildByName("left_top_container")
    self.left_top_container:setPositionX(display.getLeft())
    self.left_top_container:setPositionY(display.getTop())
    self.right_top_container = self.root_wnd:getChildByName("right_top_container")
    self.right_top_container:setPositionX(display.getRight())
    self.right_top_container:setPositionY(display.getTop())

    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())
    --背景
    local bg_res = PathTool.getPlistImgForDownLoad("gw_arena", "gw_arena_46_bg_ranking", true)
    if not self.background_load then
        self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
    end

    self.container = self.root_wnd:getChildByName("container")

    --返回上一级
    self.back_btn = self.left_top_container:getChildByName("back_btn")
    self.back_btn:getChildByName("label"):setString(UI_TI18N(10000002))
    self.back_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ArenaController:getInstance():gw_openArenaChampionRankHallWindow(false)
        end
    end)
    --返回主城
    self.home_btn = self.right_top_container:getChildByName("home_btn")
    self.home_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            BackToHome()
        end
    end)
    --上方资产
    self.top_num_wealth_list = {}
    for i=1,2 do
        self.top_num_wealth_list[i] = {}
        if i==1 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("gold_info")
        else
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("diamond_info")
        end
        self.top_num_wealth_list[i].icon = self.top_num_wealth_list[i].btn:getChildByName("icon")
        self.top_num_wealth_list[i].value = self.top_num_wealth_list[i].btn:getChildByName("label")
    end

    --详细排行
    self.rank_reward_btn = self.right_top_container:getChildByName("rank_reward_btn")
    self.rank_reward_btn_label = self.rank_reward_btn:getChildByName("label")
    StringUtil.gw_setLabelContent(self.rank_reward_btn_label, UI_TI18N(67005), 100)
    self.rank_reward_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ArenaController:getInstance():openArenaChampionRankAwardsWindow(true, self.view_type, 1)
        end
    end)

    self.pos_list = {}
    for i=1,8 do
        local item = self.container:getChildByName("pos_"..i)
        item.gw_spine_node = item:getChildByName("spine_node")
        item.empty_spine = item:getChildByName("empty_spine")
        item.gw_lev = item:getChildByName("lev")
        item.gw_name = item:getChildByName("name")
        item.gw_check_btn = item:getChildByName("check_btn")
        self.pos_list[i] = item

        item.gw_check_btn:addTouchEventListener(function(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                if self.pos_list == nil or self.pos_list[i] == nil or self.pos_list[i].gw_rank_data == nil then return end
                playButtonSound2()

                RankController:getInstance():openChatMessage(self.pos_list[i].gw_rank_data.rid, self.pos_list[i].gw_rank_data.srv_id)
            end
        end)

        StringUtil.gw_setRoleNickName2(item.gw_name, UI_TI18N(31004))
        item.gw_name:setPositionX(0-item.gw_name:getContentSize().width/2)
        item.empty_spine:setVisible(false)
        item.gw_spine_node:setVisible(false)
        item.gw_lev:setVisible(false)
        item.gw_check_btn:setVisible(false)
    end

    self.pos1_honor_icon = self.pos_list[1]:getChildByName("honor")
    local pos1_honor_icon_res = PathTool.getPlistImgForDownLoad("honor","txt_cn_honor_13", false)
    if not self.pos1_honor_icon_load then
        self.pos1_honor_icon_load = loadSpriteTextureFromCDN(self.pos1_honor_icon, pos1_honor_icon_res, ResourcesType.single, self.pos1_honor_icon_load)
    end
    self.pos2_honor_icon = self.pos_list[2]:getChildByName("honor")
    local pos2_honor_icon_res = PathTool.getPlistImgForDownLoad("honor","txt_cn_honor_14", false)
    if not self.pos2_honor_icon_load then
        self.pos2_honor_icon_load = loadSpriteTextureFromCDN(self.pos2_honor_icon, pos2_honor_icon_res, ResourcesType.single, self.pos2_honor_icon_load)
    end
    self.pos3_honor_icon = self.pos_list[3]:getChildByName("honor")
    local pos3_honor_icon_res = PathTool.getPlistImgForDownLoad("honor","txt_cn_honor_15", false)
    if not self.pos3_honor_icon_load then
        self.pos3_honor_icon_load = loadSpriteTextureFromCDN(self.pos3_honor_icon, pos3_honor_icon_res, ResourcesType.single, self.pos3_honor_icon_load)
    end

    ----播放窗口动画
    --self:playEnterAnimatianByObj(self.root_wnd , 1)
end

function GW_ArenaChampionRankHallWindow:register_event()
    if role_vo then
        if self.role_update_event == nil then
            self.role_update_event = role_vo:Bind(RoleEvent.UPDATE_ROLE_ATTRIBUTE, function(key, value)
                if key == "coin" or key == "gold" or key == "red_gold" or key == "silver_coin" or key == "arena_cent" then
                    self:updateTopNumWealth()
                end
            end)
        end
    end
    self.top_num_wealth_list[1].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
        end
    end)
    self.top_num_wealth_list[2].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            --ExchangeController:getInstance():openExchangeMainView(true)
            local key = "arena_cent"
            local item_id = Config.ItemData.data_assets_label2id[key]
            local config = Config.ItemData.data_get_data(item_id)
            if config then
                BackpackController:getInstance():openTipsSource( true,config )
            end
        end
    end)

    --if self.update_rank_event == nil then
    --    self.update_rank_event = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateChampionRankEvent, function(data)
    --        self:updateRankListInfo(data)
    --    end)
    --end

    --if self.update_worship_event == nil then
    --    self.update_worship_event = GlobalEvent:getInstance():Bind(RoleEvent.WorshipOtherRole, function(rid, srv_id, idx)
    --        --if idx ~= nil and self.select_item ~= nil and self.select_item.data ~= nil then
    --        --    if idx == self.select_item.data.rank then
    --        --        self.select_item:updateWorshipStatus()
    --        --    end
    --        --end
    --    end)
    --end


    ----接受数据
    --if self.updateEvent == nil then
    --    self.updateEvent = GlobalEvent:getInstance():Bind(RoleEvent.DISPATCH_PLAYER_VO_EVENT,function ( data )
    --        if data and data.look_id then
    --            self:updatePosRoleSpine(data.rid, data.srv_id, data.look_id)
    --        end
    --    end)
    --end


    if self.update_normal_champion_top3_event == nil then
        self.update_normal_champion_top3_event = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateChampionTop3Event, function(list)
            --if list ~= nil then
            --    for i,v in pairs(list) do
            --        self:updatePosRoleSpine(v.rid, v.srv_id, v.lookid)
            --    end
            --end
            self:updateRankListInfo(list)
        end)
    end
    if self.update_cross_champion_top3_event == nil then
        self.update_cross_champion_top3_event = GlobalEvent:getInstance():Bind(CrosschampionEvent.UpdateChampionTop3Event, function(list)
            --if list ~= nil then
            --    for i,v in pairs(list) do
            --        self:updatePosRoleSpine(v.rid, v.srv_id, v.lookid)
            --    end
            --end
            self:updateRankListInfo(list)
        end)
    end

end

function GW_ArenaChampionRankHallWindow:close_callback()
    doStopAllActions(self.container)
    if self.update_normal_champion_top3_event then
        GlobalEvent:getInstance():UnBind(self.update_normal_champion_top3_event)
        self.update_normal_champion_top3_event = nil
    end
    if self.update_cross_champion_top3_event then
        GlobalEvent:getInstance():UnBind(self.update_cross_champion_top3_event)
        self.update_cross_champion_top3_event = nil
    end
    if self.updateEvent then
        GlobalEvent:getInstance():UnBind(self.updateEvent)
        self.updateEvent = nil
    end
    if self.role_update_event then
        GlobalEvent:getInstance():UnBind(self.role_update_event)
        self.role_update_event = nil
    end
    self.top_num_wealth_list = nil

    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end
    if self.pos1_honor_icon_load then
        self.pos1_honor_icon_load:DeleteMe()
        self.pos1_honor_icon_load = nil
    end
    if self.pos2_honor_icon_load then
        self.pos2_honor_icon_load:DeleteMe()
        self.pos2_honor_icon_load = nil
    end
    if self.pos3_honor_icon_load then
        self.pos3_honor_icon_load:DeleteMe()
        self.pos3_honor_icon_load = nil
    end


    if self.update_rank_event then
        GlobalEvent:getInstance():UnBind(self.update_rank_event)
        self.update_rank_event = nil
    end
    --if self.update_worship_event then
    --    GlobalEvent:getInstance():UnBind(self.update_worship_event)
    --    self.update_worship_event = nil
    --end

    if self.pos_list then
        for i, pos_item in pairs(self.pos_list) do
            if pos_item.gw_spine_node_spine ~= nil then
                pos_item.gw_spine_node_spine:clearTracks()
                pos_item.gw_spine_node_spine:removeFromParent()
                pos_item.gw_spine_node_spine = nil
            end
        end

        self.pos_list = nil
    end

    ArenaController:getInstance():gw_openArenaChampionRankHallWindow(false)
end
--==============================--
--desc:移除ui这个操作只有在切换账号的时候触发
--time:2021-06-29 10:51:38
--@return
--==============================--
function GW_ArenaChampionRankHallWindow:__delete()
end

--刷新上方货币
function GW_ArenaChampionRankHallWindow:updateTopNumWealth()
    if not self.top_num_wealth_list then return end

    if self.top_num_wealth_list[1] ~= nil then
        local key = "gold"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[1].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[1].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[1].btn:setVisible(true)
    end
    if self.top_num_wealth_list[2] ~= nil then
        local key = "arena_cent"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[2].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[2].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[2].btn:setVisible(true)
    end
end

--刷新排行榜信息
function GW_ArenaChampionRankHallWindow:updateRankListInfo(data)
    doStopAllActions(self.container)
    for i, pos_item in pairs(self.pos_list) do
        local rank_data = self:getRankData(i, data)
        pos_item.gw_rank_data = rank_data
        if rank_data == nil then
            StringUtil.gw_setRoleNickName2(pos_item.gw_name, UI_TI18N(31004))
            pos_item.gw_name:setPositionX(0-pos_item.gw_name:getContentSize().width/2)
            pos_item.gw_spine_node:setVisible(false)
            pos_item.empty_spine:setVisible(true)
            pos_item.gw_lev:setVisible(false)
            pos_item.gw_check_btn:setVisible(false)
        else
            StringUtil.gw_setRoleNickName2(pos_item.gw_name, rank_data.name)
            pos_item.gw_lev:setString(StringFormat("Lv.{0}", rank_data.lev))
            local scale = 1
            local total_width = pos_item.gw_name:getContentSize().width + pos_item.gw_lev:getContentSize().width + 5
            if total_width > 245 then
                scale = 245/total_width
            end
            pos_item.gw_lev:setPositionX(0-scale*(pos_item.gw_name:getContentSize().width + pos_item.gw_lev:getContentSize().width + 5)/2)
            pos_item.gw_name:setPositionX(pos_item.gw_lev:getPositionX() + pos_item.gw_lev:getContentSize().width*scale + 5*scale)
            pos_item.gw_spine_node:setVisible(true)
            pos_item.empty_spine:setVisible(false)
            pos_item.gw_lev:setVisible(true)
            pos_item.gw_check_btn:setVisible(true)

            delayRun(self.container, 0.02*i,function ()
                self:updatePosRoleSpine(rank_data.rid, rank_data.srv_id, rank_data.lookid)
            end)
            --if rank_data.rid == role_vo.rid and rank_data.srv_id == role_vo.srv_id then
            --    self:updatePosRoleSpine(rank_data.rid, rank_data.srv_id)
            --else
            --    if i > 3 then
            --        RoleController:getInstance():requestRoleInfo(rank_data.rid, rank_data.srv_id)
            --    end
            --end
        end
    end
end
function GW_ArenaChampionRankHallWindow:getRankData(rank, data)
    if data == nil or data == nil then return nil end

    for i,v in pairs(data) do
        if v.rank == rank then
            return v
        end
    end

    return nil
end
function GW_ArenaChampionRankHallWindow:updatePosRoleSpine(rid, srv_id, gw_look_id)
    for i, pos_item in pairs(self.pos_list) do
        if pos_item.gw_rank_data and pos_item.gw_rank_data.rid == rid and pos_item.gw_rank_data.srv_id == srv_id then
            local look_id = gw_look_id or role_vo.look_id
            if rid == role_vo.rid and srv_id == role_vo.srv_id then
                look_id = role_vo.look_id
            end

            if pos_item.gw_look_id == nil or pos_item.gw_look_id ~= look_id then
                pos_item.gw_look_id = look_id

                if pos_item.gw_spine_node_spine ~= nil then
                    pos_item.gw_spine_node_spine:clearTracks()
                    pos_item.gw_spine_node_spine:removeFromParent()
                    pos_item.gw_spine_node_spine = nil
                end
                local config = Config.PartnerData.data_partner_base[look_id]
                if config == nil then
                    Debug.error("找不到英雄配置！！ID:"..look_id)
                else
                    local spine_res = config.spine_res

                    pos_item.gw_spine_node_spine = gw_createEffectSpine(spine_res, cc.p(0, 0), cc.p(0.5, 0), true, PlayerAction.gw_idle)
                    pos_item.gw_spine_node:addChild(pos_item.gw_spine_node_spine)
                    local spine_scale = 1
                    local offset_x = 0
                    local offset_y = 0
                    local spine_scale_config = Config.PartnerData.data_model_scale_offset_fun(config.bid)
                    if spine_scale_config then
                        spine_scale = spine_scale_config.show_scale/1000
                        offset_x = spine_scale_config.show_coordinate[1]
                        offset_y = spine_scale_config.show_coordinate[2]
                    end
                    pos_item.gw_spine_node_spine:setPosition(cc.p(0+offset_x,0+offset_y))
                    pos_item.gw_spine_node_spine:setScale(spine_scale)
                end
            end
            return
        end
    end
end

